%{!?scl:%global pkg_name %{name}}
%{?scl:%scl_package rubygem-%{gem_name}}
%global gem_name passenger

Summary: Passenger Ruby web application server
Name: %{?scl:%scl_prefix}rubygem-%{gem_name}
Version: 3.0.17
Release: 11%{?dist}
Group: System Environment/Daemons
License: Boost and BSD and BSD with advertising and MIT and zlib
URL: http://www.modrails.com
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Source: http://rubyforge.org/frs/download.php/76329/%{gem_name}-%{version}.tar.gz
Source1: passenger.logrotate
Source2: rubygem-passenger.tmpfiles
Source10: apache-passenger.conf.in
#Source20: nginx-passenger.conf.in
# Selinux configuration files
Source200: rubygem-passenger.fc
Source201: rubygem-passenger.if
Source202: rubygem-passenger.te

# Get passenger to recognize our path preferences
Patch1:         rubygem-passenger-3.0.12-force-native.patch

# Include sys/types.h for GCC 4.7
Patch2:         rubygem-passenger-3.0.14-gcc47-include-sys_types.patch

#Patch10:        rubygem-passenger-3.0.12-spoof-nginx-install.patch

# Support spawnIpAddress option to allow binding to a particular IP.
Patch20:        rubygem-passenger-3.0.12-spawn-ip.patch

# Honor CXXFLAGS in the environment.
Patch100:       passenger_apache_fix_autofoo.patch

# Test tries to spawn 1000 threads with 256kb stacks. Default Linux settings
# deny allocating so much, causing test to fail. Let's use 8kb stacks instead.
Patch102:       passenger_dynamic_thread_group.patch

# Use rspec2 conventions
Patch103:       passenger_rspec2_helper.patch

# Remove checking for fastthread on F17+
Patch104:       passenger_fixdeps.patch

# removes -Werror in upstream build scripts.  -Werror conflicts with
# -D_FORTIFY_SOURCE=2 causing warnings to turn into errors.
#Patch200:       nginx-auto-cc-gcc.patch

Requires: %{?scl:%scl_prefix}rubygems
#Requires: %{?scl:%scl_prefix}rubygem(daemon_controller) >= 0.2.5
Requires: %{?scl:%scl_prefix}rubygem(file-tail)
Requires: %{?scl:%scl_prefix}rubygem(rack)
Requires: %{?scl:%scl_prefix}rubygem(rake)

%if 0%{?rhel} >= 6 || 0%{?fedora} >= 15
BuildRequires:  libcurl-devel
%else
BuildRequires:  curl-devel
%endif

# native build deps
BuildRequires: libselinux-devel
%if 0%{?rhel} >= 6 || 0%{?fedora} >= 15
BuildRequires:  selinux-policy
%else
BuildRequires:  selinux-policy-devel
%endif

BuildRequires: asciidoc
BuildRequires: doxygen
BuildRequires: graphviz
BuildRequires: httpd-devel
BuildRequires: libev-devel
BuildRequires: %{?scl:%scl_prefix}ruby
BuildRequires: %{?scl:%scl_prefix}ruby-devel
BuildRequires: %{?scl:%scl_prefix}rubygems
BuildRequires: %{?scl:%scl_prefix}rubygems-devel
BuildRequires: %{?scl:%scl_prefix}rubygem(rake) >= 0.8.1
BuildRequires: %{?scl:%scl_prefix}rubygem(rack)
BuildRequires: %{?scl:%scl_prefix}rubygem(rspec)
BuildRequires: %{?scl:%scl_prefix}rubygem(mime-types)
BuildRequires: source-highlight

# XXX
BuildRequires: zlib-devel

Provides: %{?scl:%scl_prefix}rubygem(%{gem_name}) = %{version}
Provides: %{?scl:%scl_prefix}bundled(boost) =  1.44

%description
Phusion Passenger™ — a.k.a. mod_rails or mod_rack — makes deployment
of Ruby web applications, such as those built on the revolutionary
Ruby on Rails web framework, a breeze. It follows the usual Ruby on
Rails conventions, such as “Don’t-Repeat-Yourself”.

%package -n %{?scl:%scl_prefix}mod_passenger
Summary: Apache Module for Phusion Passenger
Group: System Environment/Daemons
BuildRequires:  httpd-devel
Requires: httpd >= 2.2
Requires: %{?scl:%scl_prefix}rubygem(%{gem_name}) = %{version}-%{release}
License: Boost and BSD and BSD with advertising and MIT and zlib

%description -n %{?scl:%scl_prefix}mod_passenger
Phusion Passenger™ — a.k.a. mod_rails or mod_rack — makes deployment
of Ruby web applications, such as those built on the revolutionary
Ruby on Rails web framework, a breeze. It follows the usual Ruby on
Rails conventions, such as “Don’t-Repeat-Yourself”.

This package contains the pluggable Apache server module for Passenger.

%package devel
Summary: Apache Module for Phusion Passenger
Group: System Environment/Daemons
Requires: %{?scl:%scl_prefix}rubygem(%{gem_name}) = %{version}
Provides: %{?scl:%scl_prefix}bundled(boost-devel) =  1.44
License: Boost and BSD and BSD with advertising and MIT and zlib

%description devel
Phusion Passenger™ — a.k.a. mod_rails or mod_rack — makes deployment
of Ruby web applications, such as those built on the revolutionary
Ruby on Rails web framework, a breeze. It follows the usual Ruby on
Rails conventions, such as “Don’t-Repeat-Yourself”.

This package contains development files for Passenger.

%package doc
Summary: Apache Module for Phusion Passenger
Group: System Environment/Daemons
Requires: %{?scl:%scl_prefix}rubygem(%{gem_name}) = %{version}
License: CC-BY-SA and MIT and (MIT or GPL+)

%description doc
Phusion Passenger™ — a.k.a. mod_rails or mod_rack — makes deployment
of Ruby web applications, such as those built on the revolutionary
Ruby on Rails web framework, a breeze. It follows the usual Ruby on
Rails conventions, such as “Don’t-Repeat-Yourself”.

This package contains documentation files for Passenger.

%package native
Summary: Phusion Passenger native extensions
Group: System Environment/Daemons
Requires: %{?scl:%scl_prefix}rubygem(%{gem_name}) = %{version}
Requires: %{?scl:%scl_prefix}rubygem-passenger-native-libs = %{version}-%{release}
Requires: policycoreutils, checkpolicy, initscripts
Provides: %{?scl:%scl_prefix}rubygem-passenger-native = %{version}

%description native
Phusion Passenger™ — a.k.a. mod_rails or mod_rack — makes deployment
of Ruby web applications, such as those built on the revolutionary
Ruby on Rails web framework, a breeze. It follows the usual Ruby on
Rails conventions, such as “Don’t-Repeat-Yourself”.

This package contains the native code extensions for Apache & Nginx bindings

%package native-libs
Summary: Phusion Passenger native extensions
Group: System Environment/Daemons
Requires: %{?scl:%scl_prefix}ruby
Provides: %{?scl:%scl_prefix}rubygem-passenger-native-libs = %{version}
%description native-libs
Phusion Passenger™ — a.k.a. mod_rails or mod_rack — makes deployment
of Ruby web applications, such as those built on the revolutionary
Ruby on Rails web framework, a breeze. It follows the usual Ruby on
Rails conventions, such as “Don’t-Repeat-Yourself”.

This package contains the native shared library for Apache & Nginx
bindings, built against ruby sources. It has been separated so that
installing a new ruby interpreter only necessitates rebuilding this
package.


%prep
%setup -q -n %{gem_name}-%{version}

%patch1   -p1 -b .force-native
%patch2   -p1 -b .include-sys-types
%patch20  -p1 -b .spawnip
%patch100 -p0 -b .autofoo
%patch102 -p1 -b .threadtest
%patch103 -p1 -b .rspec2

# remove fastthread checking
%if 0%{?fedora} >= 17
%patch104 -p1 -b .fastthread
%endif

# Don't use bundled libev
%{__rm} -rf ext/libev

# asciidoc 8.4.x doesn't have an html5 backend
%{__sed} -i 's/-b html5/-b html4/' build/documentation.rb

# fix up install paths
%{__sed} -i \
    -e 's|%%%%GEM_INSTALL_DIR%%%%|%{gem_instdir}|g' \
    -e 's|%%%%APACHE_INSTALLED_MOD%%%%|%{?scl:%_root_libdir}%{!?scl:%_libdir}/httpd/modules/|g' \
    -e 's|%%%%AGENTS_DIR%%%%|%{gem_instdir}/agents|g' \
    -e 's|%%%%NATIVE_SUPPORT_DIR%%%%|%{gem_extdir}/lib|g' \
    lib/phusion_passenger.rb \
    lib/phusion_passenger/native_support.rb \
    ext/common/ResourceLocator.h

# Why are there executable header files? WTF.
for script in `find . -type f -perm /a+x -name "*.rb" -o -perm /a+x -name "*.h"`; do
    [ -z "`head -n 1 $script | grep \"^#!/\"`" ] && chmod -v 644 $script
done

# Find files with a hash-bang that do not have executable permissions
for script in `find . -type f ! -perm /a+x -name "*.rb"`; do
    [ ! -z "`head -n 1 $script | grep \"^#!/\"`" ] && chmod -v 755 $script
done


%build
export USE_VENDORED_LIBEV=false
CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ;
CXXFLAGS="${CXXFLAGS:-%optflags}" ; export CXXFLAGS ;
FFLAGS="${FFLAGS:-%optflags}" ; export FFLAGS ;

%{?scl:scl enable %scl - << \EOF}
rake package
rake apache2
#rake nginx
%{?scl:EOF}

# Setup Selinux
rm -rf selinux
mkdir selinux
cd selinux
cp %{SOURCE200} %{name}.fc
cp %{SOURCE201} %{name}.if
cp %{SOURCE202} %{name}.te
%{__sed} -i -e 's|@GEMINSTALLDIR@|%{gem_instdir}|g' %{name}.fc
%{__sed} -i -e 's|@GEMEXTDIR@|%{gem_extdir}|g' %{name}.fc
%{__sed} -i -e 's|@MODULENAME@|%{name}|g' %{name}.te
cat %{name}.fc
cat %{name}.te
#checkmodule -M -m -o rubygem-passenger.mod rubygem-passenger.te
#semodule_package -o rubygem-passenger.pp -m rubygem-passenger.mod -f rubygem-passenger.fc
make -f /usr/share/selinux/devel/Makefile
cd ..

%install
%{__rm} -rf %{buildroot}
export USE_VENDORED_LIBEV=false

# Install the gem.
%{?scl:scl enable %scl "}
gem install -V \
            --local \
            --install-dir %{buildroot}%{gem_dir} \
            --bindir %{buildroot}%{_bindir} \
            --force \
            --rdoc \
            pkg/%{gem_name}-%{version}.gem
%{?scl:"}

# Relocate the bin files to the proper location.
%{__mv} %{buildroot}%{gem_instdir}/bin/* %{buildroot}/%{_bindir}
rmdir %{buildroot}%{gem_instdir}/bin

# Install Apache module.
%{__mkdir_p} %{buildroot}/%{?scl:%_root_libdir}%{!?scl:%_libdir}/httpd/modules
install -pm 0755 ext/apache2/mod_passenger.so %{buildroot}/%{?scl:%_root_libdir}%{!?scl:%_libdir}/httpd/modules/%{?scl:%scl_prefix}mod_passenger.so

# Install Apache config.
%{__mkdir_p} %{buildroot}/%{?scl:%_root_sysconfdir}%{!?scl:%_sysconfdir}/httpd/conf.d
install -pm 0644 %{SOURCE10} %{buildroot}%{?scl:%_root_sysconfdir}%{!?scl:%_sysconfdir}/httpd/conf.d/%{?scl:%scl_prefix}passenger.conf
%{__sed} -i -e 's|@PASSENGERROOT@|%{gem_instdir}|g' \
            -e 's|PassengerRuby /usr/bin/ruby|PassengerRuby %{?scl:%_scl_root}/usr/bin/ruby|' \
            -e 's|LoadModule passenger_module modules/mod_passenger.so|LoadModule passenger_module modules/%{?scl:%scl_prefix}mod_passenger.so|' \
         %{buildroot}/%{?scl:%_root_sysconfdir}%{!?scl:%_sysconfdir}/httpd/conf.d/%{?scl:%scl_prefix}passenger.conf

# Install man pages into the proper location.
%{__mkdir_p} %{buildroot}%{_mandir}/man1
%{__mkdir_p} %{buildroot}%{_mandir}/man8
%{__mv} %{buildroot}%{gem_instdir}/man/*.1 %{buildroot}%{_mandir}/man1
%{__mv} %{buildroot}%{gem_instdir}/man/*.8 %{buildroot}%{_mandir}/man8
rmdir %{buildroot}%{gem_instdir}/man

# The agents aren't in the gem for some reason...
%{__chmod} -R 0755 agents/*
%{__cp} -a agents %{buildroot}%{gem_instdir}

# Make our ghost log and run directories...
%{__mkdir_p} %{buildroot}%{_var}/log/passenger-analytics
%{__mkdir_p} %{buildroot}%{?scl:%_root_localstatedir}%{!?scl:%_localstatedir}/run/%{pkg_name}

# logrotate
%{__mkdir_p} %{buildroot}%{?scl:%_root_sysconfdir}%{!?scl:%_sysconfdir}/logrotate.d
install -pm 0644 %{SOURCE1} %{buildroot}%{?scl:%_root_sysconfdir}%{!?scl:%_sysconfdir}/logrotate.d/passenger

# Fix wrong EOF encoding on the RI files...
for file in `find %{buildroot}%{gem_docdir} -type f -name "*.ri"`; do
    sed -i 's/\r//' $file
done
    
# Bring over just the native binaries
%{__mkdir_p} %{buildroot}%{gem_extdir}/lib/native
install -m 0755 ext/ruby/ruby*linux/passenger_native_support.so %{buildroot}%{gem_extdir}/lib/native/

# Remove zero-length files
find %{buildroot}%{gem_instdir} -type f -size 0c -delete


# Fix anything executable that does not have a hash-bang
# Why are there executable header files? WTF.
for script in `find %{buildroot}%{gem_instdir} -type f -perm /a+x -name "*.rb" -o -perm /a+x -name "*.h"`; do
    [ -z "`head -n 1 $script | grep \"^#!/\"`" ] && chmod -v 644 $script
done

# Find files with a hash-bang that do not have executable permissions
for script in `find %{buildroot}%{gem_instdir} -type f ! -perm /a+x -name "*.rb"`; do
    [ ! -z "`head -n 1 $script | grep \"^#!/\"`" ] && chmod -v 755 $script
done

# SELINUX
install -p -m 644 -D selinux/%{name}.fc %{buildroot}%{_datadir}/selinux/packages/%{name}/%{name}.fc
install -p -m 644 -D selinux/%{name}.te %{buildroot}%{_datadir}/selinux/packages/%{name}/%{name}.te
install -p -m 644 -D selinux/%{name}.if %{buildroot}%{_datadir}/selinux/packages/%{name}/%{name}.if
install -p -m 644 -D selinux/%{name}.pp %{buildroot}%{_datadir}/selinux/packages/%{name}/%{name}.pp

%clean
%{__rm} -rf %{buildroot}

%check
export USE_VENDORED_LIBEV=false
# Run the tests, capture the output, but don't fail the build if the tests fail
#
# Test failure output:
# EventedClientTest: ................[17=F].[19=F].[21=F]
# LoggingTest: ..........[12=F]................
#
%{?scl:scl enable %scl "}
rake test --trace ||:
%{?scl:"}

%post native
if [ "$1" -le "1" ] ; then # First install
semodule -i %{_datadir}/selinux/packages/%{name}/%{name}.pp 2>/dev/null || :
fixfiles -R %{name} restore
fixfiles -R %{name}-native restore
fi

%preun native
if [ "$1" -lt "1" ] ; then # Final removal
semodule -r %{name} 2>/dev/null || :
fixfiles -R %{name} restore
fixfiles -R %{name}-native restore
fi

%postun native
if [ "$1" -ge "1" ] ; then # Upgrade
semodule -i %{_datadir}/selinux/packages/%{name}/%{name}.pp 2>/dev/null || :
fixfiles -R %{name} restore
fixfiles -R %{name}-native restore
fi

%files
%doc %{gem_instdir}/README
%doc %{gem_instdir}/LICENSE
%doc %{gem_instdir}/NEWS
%{gem_cache}
%{gem_spec}
%dir %{gem_instdir}
%{_bindir}/%{gem_name}
%{_bindir}/%{gem_name}-*
# XXX: removing everything in bin until daemon_controller >= 1.0.0
#%{gem_instdir}/bin
%{gem_instdir}/helper-scripts
%{gem_instdir}/lib
%{gem_instdir}/resources
%{_mandir}/man1/%{gem_name}-*
%{_mandir}/man8/%{gem_name}-*
%dir %{?scl:%_root_localstatedir}%{!?scl:%_localstatedir}/run/rubygem-passenger
%exclude %{gem_instdir}/configure
%exclude %{gem_instdir}/debian/
%exclude %{gem_cache}

# Exclude because @natively_packaged is defined by the existence of either
# DEVELOPERS.TXT or Rakefile and will modify passenger global paths that
# make the native module unable to be found
%exclude %{gem_instdir}/DEVELOPERS.TXT

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/doc

%files devel
%doc %{gem_instdir}/INSTALL
%doc %{gem_instdir}/PACKAGING.TXT
%{gem_instdir}/test
%{gem_instdir}/build
%{gem_instdir}/dev
%{gem_instdir}/ext


# Exclude because @natively_packaged is defined by the existence of either
# DEVELOPERS.TXT or Rakefile and will modify passenger global paths that
# make the native module unable to be found
%exclude %{gem_instdir}/Rakefile

%files -n %{?scl:%scl_prefix}mod_passenger
%defattr(-, root, root, -)
%config(noreplace) %{?scl:%_root_sysconfdir}%{!?scl:%_sysconfdir}/httpd/conf.d/%{?scl:%scl_prefix}passenger.conf
%doc doc/Users\ guide\ Apache.html
%doc doc/Users\ guide\ Apache.txt
%{?scl:%_root_libdir}%{!?scl:%_libdir}/httpd/modules/%{?scl:%scl_prefix}mod_passenger.so

%files native
%defattr(-, root, root, -)
%{gem_instdir}/agents
%{_datadir}/selinux/packages/%{name}/
%dir %{_var}/log/passenger-analytics
%{?scl:%_root_sysconfdir}%{!?scl:%_sysconfdir}/logrotate.d/passenger

%files native-libs
%dir %{gem_extdir}
%{gem_extdir}/lib

%changelog
* Tue May 07 2013 Adam Miller <admiller@redhat.com> - 3.0.17-11
- BZ#959583 fix passenger-analytics log dir for ruby193-mod_passenger

* Fri Jan 11 2013 Adam Miller <admiller@redhat.com> - 3.0.17-10
- exclude DEVELOPERS.TXT and Rakefile to fix @natively_packaged

* Fri Jan 11 2013 Adam Miller <admiller@redhat.com> - 3.0.17-9
- install passenger_native_support.so to proper location

* Fri Jan 11 2013 Adam Miller <admiller@redhat.com> - 3.0.17-8
- fixed AGENTS_DIR modifier to point to the right place for the SCL-ized version

* Fri Jan 11 2013 Adam Miller <admiller@redhat.com> - 3.0.17-7
- Added AGENTS_DIR modifier

* Tue Dec 18 2012 Adam Miller <admiller@redhat.com> - 3.0.17-6
- moved passenger_native_support.so to proper location in SCL-ized passenger
  search path

* Mon Dec 17 2012 Adam Miller <admiller@redhat.com> - 3.0.17-5
- Move the agents path, doesn't like gem_extdir in SCL environment

* Thu Dec 13 2012 Troy Dawson <tdawson@redhat.com> - 3.0.17-4
- Fix selinux settings, paths changed

* Tue Dec 04 2012 Adam Miller <admiller@redhat.com> - 3.0.17-3
- Bring OpenShift SCL package inline with upstream Fedora package

* Fri Sep 19 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-20
- Fix missing selinux settings - by tdawson (#882389)

* Fri Sep 19 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-19
- Fix selinux conflicts - by rmillner (#865082)

* Thu Sep 06 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-18
- Change selinux modules to be variable name instead of fixed name

* Tue Aug 28 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-17
- Added prespawn patch (#852215)

* Fri Jun 15 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-16
- Updated selinux policy

* Fri Jun 15 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-14
- Re-Added the selinux scripts

* Fri Jun 15 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-13
- Re-Added the selinux stuff

* Thu Jun 14 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-12
- Added the spawnip patch

* Thu Jun 14 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-11
- Fine tuning the mod_passenger stuff

* Thu Jun 14 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-10
- Fixed so mod_passenger.so doesn't conflict

* Thu Jun 14 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-9
- Fixed httpd/conf.d/*passenger.conf to not conflict

* Thu Jun 14 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-8
- Added provides to native package

* Wed Jun 13 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-7
- Fixed duplicate name in the native-libs package

* Mon Jun 11 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-6
- Changed spec file to work with scl
- Rebuilt for scl
- Removed selinux modules to finally get it built.

* Tue Jun 05 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-5
- Add all the selinux files

* Tue Jun 05 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-4
- Added selinux configurations

* Tue Jun 05 2012 Troy Dawson <tdawson@redhat.com> - 3.0.12-3
- Added native and native-libs rpms.

* Mon Apr 16 2012 Brett Lentz <blentz@redhat.com> - 3.0.12-2
- Add dist to release.
- Shuffle around deprecated buildrequires and requires.

* Mon Apr 16 2012 Brett Lentz <blentz@redhat.com> - 3.0.12-1
- Update to 3.0.12
- Incorporate specfile changes from kanarip's version

* Wed Apr 12 2012 Brett Lentz <blentz@redhat.com> - 3.0.11-1
- Initial spec file
